package frc.robot;

import edu.wpi.first.math.geometry.Translation2d;

public final class Constants {
    public static int LF_DRIVE = 1;
    public static int LF_TURN = 2;
    public static int RF_DRIVE = 3;
    public static int RF_TURN = 4;
    public static int LB_DRIVE = 5;
    public static int LB_TURN = 6;
    public static int RB_DRIVE = 7;
    public static int RB_TURN = 8;

    public static int SHOOTER = 10;

    public static int GATHER_LOW = 20;
    public static int GATHER_HIGH_BACK = 21;
    public static int GATHER_HIGH_FRONT = 22;

    public static int SHEAR_LEFT = 30;
    public static int SHEAR_RIGHT = 31;

    public static int LF_POD_ZERO_DIO = 0;
    public static int RF_POD_ZERO_DIO = 1;
    public static int LB_POD_ZERO_DIO = 2;
    public static int RB_POD_ZERO_DIO = 3;
    public static int GATHER_LOW_DIO = 4;
    public static int GATHER_HIGH_DIO = 5;

    public static double TURN_P = 1.0;
    public static double TURN_I = 0.0;
    public static double TURN_D = 0.0;

    public static double SHEAR_P = 1.0;
    public static double SHEAR_I = 0.0;
    public static double SHEAR_D = 0.0;

    public static double JOY_DRIVE_EXPO = 5.0;
    public static double JOY_TURN_EXPO = 5.0;

    public static double SHOOTER_RPM = 1.0;
    public static double SHOOTER_TARGET_ERROR = 0.1;

    public static double SHEAR_TOLERANCE = 0.1;

    // 2048 CPS * 2 (quadrature)
    public static double SHOOTER_COUNTS_PER_REV = 2048.0 * 2.0;

    // 2048 CPS * 2 (quadrature) * 72 / 44 ratio
    public static double POD_COUNTS_PER_REV = 2048.0 * 2.0 * 72.0 / 44.0;

    public static double SHEAR_COUNTS_PER_REV = 2048.0 * 2.0 * 100.0;

    // drive full speed meters
    public static double DRIVE_MAX_SPEED = 9.144;
    // public static double DRIVE_MAX_SPEED = 1.0;

    // meters
    public static double swerveXFromCenter = 0.2794;
    public static double swerveYFromCenter = 0.3175;

    public static Translation2d LF_TRANSLATION = new Translation2d(swerveXFromCenter, swerveYFromCenter);
    public static Translation2d RF_TRANSLATION = new Translation2d(swerveXFromCenter, -swerveYFromCenter);
    public static Translation2d LB_TRANSLATION = new Translation2d(-swerveXFromCenter, swerveYFromCenter);
    public static Translation2d RB_TRANSLATION = new Translation2d(-swerveXFromCenter, -swerveYFromCenter);
}
