package frc.robot.commands;

import edu.wpi.first.wpilibj2.command.CommandBase;
import frc.robot.Constants;
import frc.robot.RobotContainer;
import frc.robot.Utils;
import frc.robot.subsystems.Chassis;

public class DriveWithJoysticks extends CommandBase {
  private final Chassis m_chassis;

  public DriveWithJoysticks(Chassis chassis) {
    addRequirements(chassis);
    m_chassis = chassis;

  }

  @Override
  public void initialize() {
    // m_chassis.zeroPodEncoders();
    // m_chassis.zeroGyro();
  }

  @Override
  public void execute() {
    // Get joystick values
    double x = RobotContainer.s_driver.getY() * 2.0;
    double y = RobotContainer.s_driver.getX() * 2.0;
    double theta = RobotContainer.s_driver.getZ() * 1.5;

    // Apply exponential to allow finer driver control
    x = Utils.joyExpo(x, Constants.JOY_DRIVE_EXPO);
    y = Utils.joyExpo(y, Constants.JOY_DRIVE_EXPO);
    theta = Utils.joyExpo(theta, Constants.JOY_DRIVE_EXPO);

    // TODO: Move this crap
    // double total = 0.0;
    // for(int i = 0; i < 16; i++)
    //   total += RobotContainer.s_pdp.getCurrent(i);
    // System.out.println("A: " + total + ", W: " + RobotContainer.s_pdp.getTotalPower());
    m_chassis.driveFR(x, y, theta);
  }

  @Override
  public void end(boolean interrupted) {}

  @Override
  public boolean isFinished() {
    return false;
  }
}
