package frc.robot.commands;

import edu.wpi.first.wpilibj.Timer;
import edu.wpi.first.wpilibj2.command.CommandBase;
import frc.robot.subsystems.Gatherer;
import frc.robot.subsystems.PotatoCannon;

public class Shoot extends CommandBase {
  private PotatoCannon m_cannon;
  private Gatherer m_gatherer;

  private double m_startTime;

  public Shoot(PotatoCannon cannon, Gatherer gatherer) {
    addRequirements(cannon, gatherer);
    m_cannon = cannon;
    m_gatherer = gatherer;
  }

  @Override
  public void initialize() {
    m_startTime = Timer.getFPGATimestamp();
  }

  @Override
  public void execute() {
    // if(m_cannon.isAtSpeed()) {
      m_gatherer.shoot(false);
      if(Timer.getFPGATimestamp() - m_startTime > 1.0) {
        m_gatherer.shoot(true);
      }
  }

  @Override
  public void end(boolean interrupted) {
    m_gatherer.stop();
  }

  @Override
  public boolean isFinished() {
    return false;
  }
}
