package frc.robot.subsystems;

import com.ctre.phoenix.motorcontrol.ControlMode;
import com.ctre.phoenix.motorcontrol.FeedbackDevice;
import com.ctre.phoenix.motorcontrol.can.TalonSRX;

import edu.wpi.first.wpilibj2.command.SubsystemBase;
import frc.robot.Constants;

public class Shear extends SubsystemBase {
  public TalonSRX m_left = new TalonSRX(Constants.SHEAR_LEFT);
  public TalonSRX m_right = new TalonSRX(Constants.SHEAR_RIGHT);

  public Shear() {
    m_left.setInverted(true);
    // m_right.setInverted(true);

    m_left.configSelectedFeedbackSensor(FeedbackDevice.CTRE_MagEncoder_Relative);
    // m_left.setSensorPhase(true);
    m_left.config_kP(0, Constants.SHEAR_P);
    m_left.config_kI(0, Constants.SHEAR_I);
    m_left.config_kD(0, Constants.SHEAR_D);

    m_right.configSelectedFeedbackSensor(FeedbackDevice.CTRE_MagEncoder_Relative);
    // m_right.setSensorPhase(true);
    m_right.config_kP(0, Constants.SHEAR_P);
    m_right.config_kI(0, Constants.SHEAR_I);
    m_right.config_kD(0, Constants.SHEAR_D);
  }

  public void set(double angle) {
    // m_shooter.set(ControlMode.Velocity, rpm * Constants.SHOOTER_COUNTS_PER_REV);
    m_left.set(ControlMode.Position, angle);
    m_right.set(ControlMode.Position, angle);
  }
  
  public boolean atTarget() {
    return (m_left.getClosedLoopError() < Constants.SHEAR_TOLERANCE) && (m_right.getClosedLoopError() < Constants.SHEAR_TOLERANCE);
  }

  public void brr() {
    m_left.set(ControlMode.PercentOutput, 1.0);
    m_right.set(ControlMode.PercentOutput, 1.0);
  }

  public void stop() {
    m_left.set(ControlMode.PercentOutput, 0.0);
    m_right.set(ControlMode.PercentOutput, 0.0);
  }

  @Override
  public void periodic() {
    // This method will be called once per scheduler run
  }

  @Override
  public void simulationPeriodic() {
    // This method will be called once per scheduler run during simulation
  }
}
